Index: org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/usability/button/JStandardizedToolButton.java
===================================================================
--- org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/usability/button/JStandardizedToolButton.java	(revision 0)
+++ org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/usability/button/JStandardizedToolButton.java	(revision 168)
@@ -0,0 +1,215 @@
+/* gvSIG. Sistema de Información Geográfica de la Generalitat Valenciana
+ *
+ * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
+ *
+ * For more information, contact:
+ *
+ *  Generalitat Valenciana
+ *   Conselleria d'Infraestructures i Transport
+ *   Av. Blasco Ibáñez, 50
+ *   46010 VALENCIA
+ *   SPAIN
+ *
+ *      +34 963862235
+ *   gvsig@gva.es
+ *      www.gvsig.gva.es
+ *
+ *    or
+ *
+ *   IVER T.I. S.A
+ *   Salamanca 50
+ *   46005 Valencia
+ *   Spain
+ *
+ *   +34 963163400
+ *   dac@iver.es
+ */
+package org.gvsig.tools.swing.impl.usability.button;
+
+import java.awt.Dimension;
+
+import javax.swing.Action;
+import javax.swing.Icon;
+import javax.swing.JButton;
+
+/**
+ * According to the gvSIG's GUI style sheet all the buttons in the application
+ * will have a normative size. No smaller than a concrete size, and big enough
+ * to contain the text and avoiding the "..." characters. The button will grow
+ * up in width by a set of widths defined in this style sheet, always choosing
+ * the smallest width that can contain the text. If the biggest width is not
+ * enought for this purpose then the button will automatically grow up to the
+ * smallest necessary width to fit the text.<br>
+ * <p>
+ * The button resizing is based on the <b>setText(String txt)</b> method.
+ * However, it is possible to use a custom size if you invoke one of
+ * <b>setSize(..)</b>, <b>setBorders(...)</b> or <b>setPreferredSize(...)</b>
+ * after invoking the <b>setText(...)<b> method.
+ * <p>
+ * This class is just a standard javax.swing.JButton that handles this issue.
+ * </p>
+ * 
+ * @author jaume dominguez faus - jaume.dominguez@iver.es
+ * 
+ */
+public class JStandardizedToolButton extends JButton {
+	private static final long serialVersionUID = -1635879317292710725L;
+
+	// TODO this should be initialized from a properties file or so.
+	private static int[][] buttonSizes = new int[][] { 
+	    new int[] {  22, 22 },
+	    new int[] {  44, 22 },
+	    new int[] {  66, 22 },
+	    new int[] {  88, 22 },
+	    new int[] { 110, 22 }, 
+	    new int[] { 132, 22 }, 
+	    new int[] { 154, 22 } };
+
+	private String enableText;
+	private String toolTip;
+
+	/**
+	 * Creates a new empty instance of org.gvsig.gui.beans.swing.JButton.
+	 */
+	public JStandardizedToolButton() {
+		super();
+	}
+
+	/**
+	 * Creates a new instance of org.gvsig.gui.beans.swing.JButton from an
+	 * {@link Action}.
+	 */
+	public JStandardizedToolButton(Action action) {
+		super(action);
+	}
+
+	/**
+	 * Creates a new instance of org.gvsig.gui.beans.swing.JButton containing an
+	 * image.
+	 */
+	public JStandardizedToolButton(Icon icon) {
+		super(icon);
+	}
+
+	/**
+	 * Creates a new instance of org.gvsig.gui.beans.swing.JButton containing a
+	 * text.
+	 * 
+	 * @param text
+	 */
+	public JStandardizedToolButton(String text) {
+		super();
+		setText(text);
+	}
+
+	/**
+	 * Creates a new instance of org.gvsig.gui.beans.swing.JButton containing an
+	 * image and a text.
+	 * 
+	 * @param text
+	 * @param icon
+	 */
+	public JStandardizedToolButton(String text, Icon icon) {
+		super(icon);
+		setText(text);
+	}
+
+	/**
+	 * Gets the text that appears in the tooltip when the button is disabled.
+	 * 
+	 * @return String
+	 */
+	public String getEnableText() {
+		return enableText;
+	}
+
+	@Override
+	public Dimension getMaximumSize() {
+		return getPreferredSize();
+	}
+
+	@Override
+	public Dimension getMinimumSize() {
+		return getPreferredSize();
+	}
+
+	@Override
+	public Dimension getPreferredSize() {
+		Dimension d = getUI().getMinimumSize(this);
+		int oldWidth = (int) d.getWidth(), newWidth = oldWidth;
+		int oldHeight = (int) d.getHeight(), newHeight = oldHeight;
+
+		// figure out the suitable width
+		for (int i = buttonSizes.length - 1; i >= 0; i--)
+			if (oldWidth < buttonSizes[i][0])
+				newWidth = buttonSizes[i][0];
+
+		// figure out the suitable height
+		for (int i = buttonSizes.length - 1; i >= 0; i--)
+			if (oldHeight < buttonSizes[i][1])
+				newHeight = buttonSizes[i][1];
+
+		return new Dimension(newWidth, newHeight);
+	}
+
+	// public void setText(String text) {
+	// super.setText(text);
+	// Dimension d = getUI().getMinimumSize(this);
+	// int oldWidth = (int) d.getWidth(), newWidth = oldWidth;
+	// int oldHeight = (int) d.getHeight(), newHeight = oldHeight;
+	//
+	// // figure out the suitable width
+	// for (int i = buttonSizes.length - 1; i >= 0; i--)
+	// if (oldWidth < buttonSizes[i][0])
+	// newWidth = buttonSizes[i][0];
+	//
+	// // figure out the suitable height
+	// for (int i = buttonSizes.length - 1; i >= 0; i--)
+	// if (oldHeight < buttonSizes[i][1])
+	// newHeight = buttonSizes[i][1];
+	//
+	// Dimension sz = new Dimension(newWidth, newHeight);
+	// super.setSize(sz);
+	// super.setPreferredSize(sz);
+	// }
+
+	public void setEnabled(boolean aFlag) {
+		super.setEnabled(aFlag);
+		if (aFlag) {
+			setToolTipText(toolTip);
+		} else {
+			setToolTipText(enableText);
+		}
+	}
+
+	/**
+	 * Sets the text that appears in the tooltip when the button is disabled.
+	 * 
+	 * @param enableText
+	 *            The enableText to set.
+	 */
+	public void setEnableText(String enableText) {
+		this.enableText = enableText;
+	}
+
+	/**
+	 * Sets the text that appears in the tooltip when the button is enabled.
+	 */
+	public void setToolTip(String text) {
+		toolTip = text;
+	}
+}
Index: org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/usability/DefaultUsabilitySwingManager.java
===================================================================
--- org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/usability/DefaultUsabilitySwingManager.java	(revision 167)
+++ org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/usability/DefaultUsabilitySwingManager.java	(revision 168)
@@ -26,12 +26,19 @@
 */
 package org.gvsig.tools.swing.impl.usability;
 
+import java.awt.Component;
+import java.awt.GridBagConstraints;
+import java.awt.GridBagLayout;
+import java.awt.Insets;
+
 import javax.swing.Action;
 import javax.swing.Icon;
 import javax.swing.JButton;
+import javax.swing.JPanel;
 
 import org.gvsig.tools.swing.api.usability.UsabilitySwingManager;
 import org.gvsig.tools.swing.impl.usability.button.JStandardizedButton;
+import org.gvsig.tools.swing.impl.usability.button.JStandardizedToolButton;
 
 /**
  * Default implementation for the {@link UsabilitySwingManager}.
@@ -40,24 +47,82 @@
  */
 public class DefaultUsabilitySwingManager implements UsabilitySwingManager {
 
+	/* (non-Javadoc)
+	 * @see org.gvsig.tools.swing.api.usability.UsabilitySwingManager#createBoxLayout(java.awt.Component, java.awt.Component, java.lang.Integer, java.lang.Integer)
+	 */
+	public JPanel createGridBagRowPanel(JPanel gridBagPanel, Component labelComponent,
+		Component fieldComponent,
+		Integer labelMargin, Integer fieldMargin) {
+	    // Create a panel that uses BoxLayout.
+	    JPanel panel;
+	    if (gridBagPanel==null){
+		panel = new JPanel();
+		panel.setLayout(new GridBagLayout());
+	    }else
+		panel = gridBagPanel;
+	    
+	    GridBagConstraints constr = this.getDefaultParametersConstraints();
+	    constr.fill = GridBagConstraints.HORIZONTAL;	   
+
+	    constr.gridwidth = GridBagConstraints.RELATIVE;
+	    constr.weighty = 0;
+	    
+	    if (labelComponent != null) {
+//		constr.weightx = 0;
+//		int width = labelComponent.getSize().width;
+		
+		if (labelMargin != null)
+		    constr.weightx = labelMargin;
+		panel.add(labelComponent, constr);
+	    }
+	    constr.fill = GridBagConstraints.NONE;  
+//	    constr.gridwidth = GridBagConstraints.RELATIVE;
+	       
+	    
+	    if (fieldComponent != null) {
+		constr.weightx = 0;
+		if (fieldMargin != null)
+		    constr.weightx = labelMargin;
+		panel.add(fieldComponent, constr);
+	    }
+	    return panel;
+	}
+
 	public JButton createJButton() {
 		return new JStandardizedButton();
 	}
 
-	public JButton createJButton(String text) {
-		return new JStandardizedButton(text);
+	public JButton createJButton(Action action) {
+		return new JStandardizedButton(action);
 	}
 
 	public JButton createJButton(Icon icon) {
 		return new JStandardizedButton(icon);
 	}
 
+	public JButton createJButton(String text) {
+		return new JStandardizedButton(text);
+	}
+	
 	public JButton createJButton(String text, Icon icon) {
 		return new JStandardizedButton(text, icon);
 	}
+	
 
-	public JButton createJButton(Action action) {
-		return new JStandardizedButton(action);
+	public JButton createJToolButton(String text) {
+		return new JStandardizedToolButton(text);
 	}
+	
+	/**
+	 * @return
+	 */
+	private GridBagConstraints getDefaultParametersConstraints() {
+	    GridBagConstraints constr = new GridBagConstraints();
+	    constr.insets = new Insets(2, 2, 2, 2);
+	    constr.ipadx = 2;
+	    constr.ipady = 2;
+	    constr.anchor = GridBagConstraints.PAGE_START;
+	    return constr;
+	}	
 
 }
\ No newline at end of file
